function Channels = ReadNDFChannels(fodername)
    nfiDir = dir(fullfile(fodername, '*.nfi'));
    if length(nfiDir) < 1
        disp('No *.nfi file was found in chosen folder.');
        return;
    end
    nfiName = nfiDir(1).name;
    folderCat = fileNFI.GetFolderCategory(fullfile(fodername, nfiName));

    switch folderCat
        case FolderType.NDFFileTypeNTP
            ntps = dir(fullfile(fodername, '*.ntp'));
            if length(ntps) < 1
                disp('No *.ntp file was found in chosen folder.');
                return;
            end
            ntpName = fullfile(fodername,ntps(1).name);
            ntp = fileNTP(ntpName);
            ntpInfo = ntp.parse();
            %fileNTPInfo.recordDate
            subs = ntpInfo.subs;
            cnt = ntpInfo.subCount;
            Channels = [];
            if cnt > 1
                for i = 1:cnt-1
                    sname = subs(i).folderName;
                    fd = fullfile(fodername,sname);
                    fldObj = FolderNHF(fd);
                    fldInfo = fldObj.getFolderInfo();
                    Channels = [Channel fldInfo];
                    delete fldObj;
                end
            end
        case FolderType.NDFFileTypeNHF
            fldObj = FolderNHF(fodername);
            fldInfo = fldObj.getFolderInfo();
            Channels = fldInfo;
            delete fldObj;
        case FolderType.NDFFileTypeNSF
            fldObj = FolderNSF(fodername);
            fldInfo = fldObj.getFolderInfo();
            Channels = fldInfo;
            delete fldObj;
    end
end