function [ChannelData,event] = ReadOneChannel(foderPath, patient,channelName,start,endT)
    nfiDir = dir(fullfile(foderPath, '*.nfi'));
    if length(nfiDir) < 1
        disp('No *.nfi file was found in chosen folder.');
        return;
    end
    nfiName = nfiDir(1).name;
    folderCat = fileNFI.GetFolderCategory(fullfile(foderPath, nfiName));
    event = struct('type',[],'latency',[]);
    dur = endT - start;
    switch folderCat
        case FolderType.NDFFileTypeNTP
            fd = fullfile(foderPath,patient);
            fldObj = FolderNHF(fd);
            ChannelData = fldObj.getFolderDataTimeRangePartialChannal(start,dur,channelName);
            delete fldObj;
        case FolderType.NDFFileTypeNHF
            fldObj = FolderNHF(foderPath);
            fldInfo = fldObj.getFolderInfo();
            ChannelData = fldObj.getFolderDataTimeRangePartialChannal(start,dur,channelName);
            nefDir = dir(fullfile(foderPath, '*.nef'));
            if ~isempty(nefDir)
                nefPath = fullfile(foderPath, nefDir(1).name);
                if ~isempty(nefPath)
                    nefObj = fileNEF(nefPath);
                    evtInfo = nefObj.nefInfo;
                    evtCnt = evtInfo.eventCount -  evtInfo.eventDelCount;
                    evtAr = evtInfo.eventAr;
                    iCnt = 0;
                    for i = 1:evtCnt
                        if evtAr(i).latency<start || evtAr(i).latency>=endT
                            continue;
                        end
                        iCnt = iCnt + 1;
                        event(iCnt).type = evtAr(i).Annotation;
                        event(iCnt).latency = evtAr(i).Onset*fldInfo.sRate;% round(evt(i).offset_in_sec*srate);
                    end
                    delete nefObj;
                end
            end
            delete fldObj;

    end

end