% eegplugin_importNDF() - EEGLAB plugin for importing NDF data files.
%
% Usage:
%   >> eegplugin_importNDF(fig, trystrs, catchstrs);
%
% Inputs:
%   fig        - [integer]  EEGLAB figure
%   trystrs    - [struct] "try" strings for menu callbacks.
%   catchstrs  - [struct] "catch" strings for menu callbacks.
% Versions:
%    v1.0:
function eegplugin_importNDF(fig, trystrs, catchstrs)
    % add folder to path
    % ------------------
    if exist('pop_importNDF', 'file')
        p = which('eegplugin_importNDF.m');
        p = p(1:findstr(p,'eegplugin_importNDF.m')-1);
        addpath(p);
    end;
    % find import data menu
    % ---------------------
    menu = findobj(fig, 'tag', 'import data');
    
    % menu callbacks
    % --------------
    comcnt = [ trystrs.no_check '[EEG, command] = pop_importNDF;' catchstrs.new_and_hist ];
    
    % create menus
    % ------------
    uimenu( menu, 'label', 'From NDF data files', 'callback', comcnt);

end