classdef fileNDF<handle
    % 20230822 debug 修改数据读取时间过长问题
    properties
      fPath
      fInfo
      fVersion
    end

    methods
      function obj = fileNDF(fpath)
        obj.fPath = fpath;
        obj.parse();
      end

      function ndfInfo = parse_v1(obj)
        fp= obj.fPath;
        fID = fopen(fp,'r','l');
        le = fread(fID,2,'uint8');
        if le(1) == hex2dec('fe') && le(2) ==  hex2dec('ff')
          ndfInfo.LE = true;
        elseif le(2) == hex2dec('fe') && le(1) ==  hex2dec('ff')
          ndfInfo.LE = false;
          fclose(fID);
          fID = fopen(fp,'r','b');
        else
          disp('error');
          return
        end

        fseek(fID,11,'bof');
        gd = fread(fID,2,'uint8');
        gend = char(gd);
        if(gend(1)=='M')
          ndfInfo.isMale = true;
        elseif (gend(1)=='F')
          ndfInfo.isMale = false;
        end

        na = fread(fID,20,'uint8');
        ndfInfo.name = NDFDecoder.Decode(na);
        ndfInfo.birthday = fscanf(fID, "%4d.%2d.%2d",3);
        ndfInfo.recordDate = fscanf(fID, "%4d.%2d.%2d",3);
        ndfInfo.recordTime = fscanf(fID, "%2d:%2d:%2d",3);
        ndfInfo.recordDuration = fread(fID,1,'uint32');
        chCount = fread(fID,1,'uint16');
        ndfInfo.chCount = chCount;
        ndfInfo.singleDuration = fread(fID,1,'int32');
        ndfInfo.maskCount = fread(fID,1,'uint16');
        ndfInfo.subID = fread(fID,16,'uint8');
        ndfInfo.examID = fread(fID,16,'uint8');
        chs = repmat(struct('ChannelName',[],'ChannelType',[],'TransducerType',[],'PreFilter',[],'Unit',[],'ByteCount',0,'SampleRate',0,'MaxDigital',0,'MinDigital',0,'MaxPhysical',0,'MinPhysical',0,'ChannelOffset',0),1,chCount);
        samplesFrame = 0;
        bytesFrame = 0;
        chNameInfoDic = containers.Map();
        chNameIndexDic = containers.Map();
        srOffset = 0;
        for i = 1:chCount
          fseek(fID,128+(i-1)*128,'bof');
          chName = fread(fID,20,'uint8');
          chs(i).ChannelName = strcat(char(chName)');
          chType = fread(fID,20,'uint8');
          chs(i).ChannelType = char(chType);
          tType = fread(fID,8,'uint8');
          chs(i).TransducerType = char(tType);
          pFileter = fread(fID,20,'uint8');
          chs(i).PreFilter = char(pFileter);
          unit = fread(fID,8,'uint8');
          chs(i).Unit = char(unit);
          bytsOneS = fread(fID,1,'uint8');
          chs(i).bytesOneSample = bytsOneS;
          sampleR = fread(fID,1,'int16');
          chs(i).SampleRate = sampleR;
          samplesFrame = samplesFrame + sampleR;
          chs(i).bytes = bytsOneS * sampleR;
          bytesFrame = chs(i).bytes  + bytesFrame;
          maxD = fread(fID,1,'int32');
          chs(i).MaxDigital = maxD;
          minD = fread(fID,1,'int32');
          chs(i).MinDigital = minD;
          maxP = fread(fID,1,'float32');
          chs(i).MaxPhysical = maxP;
          minP = fread(fID,1,'float32');
          chs(i).MinPhysical = minP;
          chs(i).D2PCoef = double(maxP - minP) / double(maxD - minD);
          chOffset = fread(fID,1,'int32');
          chs(i).ChannelOffset = chOffset;
          chNameInfoDic(chs(i).ChannelName) = chs(i);
          chNameIndexDic(chs(i).ChannelName) = srOffset;
          srOffset = srOffset + chs(i).bytes;% cache channel offset in one frame
        end
        ndfInfo.channels = chs;
        ndfInfo.samplesChFrame = samplesFrame;
        ndfInfo.bytesChFrame = bytesFrame+1+ndfInfo.maskCount;
        ndfInfo.chInfoDic = chNameInfoDic;
        ndfInfo.chIndexDic = chNameIndexDic;
        obj.fInfo = ndfInfo;
        fclose(fID);
      end
      
      function ndfInfo = parse(obj)
        fp= obj.fPath;
        fID = fopen(fp,'r','l');
        hd1Ar = fread(fID,10,'uint8');
        %le = fread(fID,2,'uint8');
        le = hd1Ar(1:2);
        ver = hd1Ar(7);
        if ver ~= 0x02
          obj.fVersion = 0x01;
          fclose(fID);
          obj.parse_v1();
          return
        end
        obj.fVersion = 0x02;

        if le(1) == hex2dec('fe') && le(2) ==  hex2dec('ff')
          ndfInfo.LE = true;
        elseif le(2) == hex2dec('fe') && le(1) ==  hex2dec('ff')
          ndfInfo.LE = false;
          fclose(fID);
          fID = fopen(fp,'r','b');
        else
          disp('error');
          return
        end

        fseek(fID,11,'bof');
        gd = fread(fID,2,'uint8');
        gend = char(gd);
        if(gend(1)=='M')
          ndfInfo.isMale = true;
        elseif (gend(1)=='F')
          ndfInfo.isMale = false;
        end

        na = fread(fID,20,'uint8');
        ndfInfo.name = NDFDecoder.Decode(na);
        ndfInfo.birthday = fscanf(fID, "%4d.%2d.%2d",3);
        ndfInfo.recordDate = fscanf(fID, "%4d.%2d.%2d",3);
        ndfInfo.recordTime = fscanf(fID, "%2d:%2d:%2d",3);
        ndfInfo.recordDuration = fread(fID,1,'uint32');
        chCount = fread(fID,1,'uint16');
        ndfInfo.chCount = chCount;
        ndfInfo.singleDuration = fread(fID,1,'int32');
        ndfInfo.maskCount = fread(fID,1,'uint16');
        ndfInfo.subID = fread(fID,16,'uint8');
        ndfInfo.examID = fread(fID,16,'uint8');
        chs = repmat(struct('ChannelName',[],'ChannelType',[],'TransducerType',[],'PreFilter',[],'Unit',[],'ByteCount',0,'SampleRate',0,'MaxDigital',0,'MinDigital',0,'MaxPhysical',0,'MinPhysical',0,'ChannelOffset',0),1,chCount);
        samplesFrame = 0;
        bytesFrame = 0;
        chNameInfoDic = containers.Map();
        chNameIndexDic = containers.Map();
        chNameRowDic = containers.Map();
        srOffset = 0;
        sampleMax  = 0;
        for i = 1:chCount
          fseek(fID,144+(i-1)*128,'bof');
          chName = fread(fID,20,'uint8');
          chs(i).ChannelName = strcat(char(chName)');
          chType = fread(fID,20,'uint8');
          chs(i).ChannelType = char(chType);
          tType = fread(fID,8,'uint8');
          chs(i).TransducerType = char(tType);
          pFileter = fread(fID,20,'uint8');
          chs(i).PreFilter = char(pFileter);
          unit = fread(fID,8,'uint8');
          chs(i).Unit = char(unit);
          bytsOneS = fread(fID,1,'uint8');
          chs(i).bytesOneSample = bytsOneS;
          sampleR = fread(fID,1,'uint16');
          chs(i).SampleRate = sampleR;
          samplesFrame = samplesFrame + sampleR;
          chs(i).bytes = bytsOneS * sampleR;
          bytesFrame = chs(i).bytes  + bytesFrame;
          maxD = fread(fID,1,'int32');
          chs(i).MaxDigital = maxD;
          minD = fread(fID,1,'int32');
          chs(i).MinDigital = minD;
          maxP = fread(fID,1,'float32');
          chs(i).MaxPhysical = maxP;
          minP = fread(fID,1,'float32');
          chs(i).MinPhysical = minP;
          chs(i).D2PCoef = double(maxP - minP) / double(maxD - minD);
          chOffset = fread(fID,1,'int32');
          chs(i).ChannelOffset = chOffset;
          chNameInfoDic(chs(i).ChannelName) = chs(i);
          chNameIndexDic(chs(i).ChannelName) = srOffset;
          chNameRowDic(chs(i).ChannelName) = i;
          srOffset = srOffset + chs(i).bytes;% cache channel offset in one frame
          if sampleMax<sampleR
              sampleMax = sampleR;   
          end
        end
        ndfInfo.channels = chs;
        ndfInfo.samplesChFrame = samplesFrame;
        ndfInfo.bytesChFrame = bytesFrame+1+ndfInfo.maskCount;
        ndfInfo.chInfoDic = chNameInfoDic;
        ndfInfo.chIndexDic = chNameIndexDic;
        ndfInfo.chRowDic = chNameRowDic;
        ndfInfo.sampleMax = sampleMax;
        
        sOffsetPage = 144+128*chCount;
        fseek(fID,sOffsetPage,'bof');
        ndfInfo.pageItemCount = fread(fID,1,'uint32');
        ndfInfo.pagesPosition = fread(fID,8,'uint64');
        pValidIndex = 0;
        for i = 1:8
          if ndfInfo.pagesPosition(i)~=0
            pValidIndex = i;
          else
            break;
          end
        end
        ndfInfo.pageUseCount=pValidIndex;
        obj.fInfo = ndfInfo;
        fclose(fID);
      end
      
      function physicalDataRes = readPeriodChannelRangePhysicalValues_V1(obj,secOffset,secDur,chNames)
        info = obj.fInfo;
        bytesFrame = info.bytesChFrame;
        fp= obj.fPath;
        fmt = 'l';
        if( info.LE == false)
          fmt ='b';
        end
        fID = fopen(fp,'r',fmt);
        chsAll = info.channels;
        durationAll = info.recordDuration;
        chCountAll = info.chCount;
        chsDic = info.chInfoDic;
        durationR = secDur;
        offsetR = secOffset;
        chNameR = chNames;
        chNameDataDic = containers.Map();
        chCountR = length(chNames);
        for i=1:chCountR
          chname = chNames(i);
            % 203231221 debug 下划线区分通道名称导致异常，修改成只针对ECG通道
          if contains(chname,'ECG')
              chname_apart = split(chname,'_');% 20230824
              chname = chname_apart{end};% 20230824
              chNames(i) = chname;% 20230824
          end

          chInfo = chsDic(char(chname));
          sCount = chInfo.SampleRate;
          datas(i) = oneChannelData();
          datas(i).Datas = zeros(sCount,durationR);
        end

        for s = 1:durationR
          for i=1:chCountR
            chname = char(strcat(chNames(i)));
            pOffset = info.chIndexDic(chname);
            offset = 128+info.chCount*128+offsetR*bytesFrame+(s-1)* bytesFrame+1+info.maskCount+pOffset;
            res = fseek(fID,offset,'bof');
            if(res~=0)
                disp("fseek error");
            end
            chInfoTmp = chsDic(chname);
            width = chInfoTmp.bytesOneSample;
            sCount = chInfoTmp.SampleRate;
            bitWidth = width*8;
            readSrc = sprintf('bit%d=>int32',bitWidth);
            minD =  chInfoTmp.MinDigital;
            if minD>=0
               readSrc = sprintf('ubit%d=>int32',bitWidth);
            end
            %chdata = fread(fID,sCount,readSrc);
            [chDSec,chDSecLen] = fread(fID,sCount,readSrc);
            if chDSecLen <1
              break;
            end
            dataOneSec =chInfoTmp.MinPhysical + chInfoTmp.D2PCoef*(double(chDSec-minD));
            datas(i).Datas(:,s) = dataOneSec;
          end
        end
        
        for i=1:chCountR
          chname = char(strcat(chNames(i)));
          chNameDataDic(char(chname)) = datas(i).Datas;
        end
        physicalDataRes = chNameDataDic;
        fclose(fID);
      end

      function physicalDataRes = readPeriodChannelRangePhysicalValues(obj,secOffset,secDur,chNames)
        info = obj.fInfo;
        if obj.fVersion == 0x01
           physicalDataRes = obj.readPeriodChannelRangePhysicalValues_V1(secOffset,secDur,chNames);
           return;
        end
        bytesFrame = info.bytesChFrame;
        fp= obj.fPath;
        fmt = 'l';
        if( info.LE == false)
          fmt ='b';
        end
        fID = fopen(fp,'r',fmt);
        chsAll = info.channels;
        durationAll = info.recordDuration;
        chCountAll = info.chCount;
        chsDic = info.chInfoDic;
        sampleRMax = info.sampleMax;
        durationR = secDur;
        offsetR = secOffset;
        chNameR = chNames;
        chNameDataDic = containers.Map();
        chCountR = length(chNames);
        for i=1:chCountR
          chname = chNames(i);
            % 203231221 debug 下划线区分通道名称导致异常，修改成只针对ECG通道
          if contains(chname,'ECG')
              chname_apart = split(chname,'_');% 20230824
              chname = chname_apart{end};% 20230824
              chNames(i) = chname;% 20230824
          end

          chInfo = chsDic(char(chname));
          sCount = chInfo.SampleRate;
          datas(i) = oneChannelData();
          datas(i).Datas = zeros(sCount,durationR);
        end
        dataPos = obj.getFPosFromTime(fID,offsetR,durationR);
        NdfDcoder = NDFDecompression();
        hDictFpos = 0;
        hDict = [];
        for s = 1:durationR
          fseek(fID,dataPos(s),'bof');
          dicPos = fread(fID,1,'uint64');
          comprOption = fread(fID,1,'uint8');
          dtLen = fread(fID,1,'uint32');
          if comprOption == 7
            dtRead = fread(fID,info.pageItemCount,'uint8');
            if dicPos ~= hDictFpos
              fseek(fID,dicPos,'bof');
              freqAr = fread(fID,256,'uint32');
              hDict = NdfDcoder.GenHuffmanTree(dicPos,freqAr);
            end
            dataDec = NdfDcoder.DecompressHVZD(dtRead,hDict,chCountAll,sampleRMax);
            for i=1:chCountR
              chname = char(strcat(chNames(i)));
              rowIdx = info.chRowDic(chname);
              chInfoTmp = chsDic(chname);
              minD =  chInfoTmp.MinDigital;
              sCount = chInfoTmp.SampleRate;
              chDSec = dataDec(rowIdx,[1:sCount]);
              dataOneSec =chInfoTmp.MinPhysical + chInfoTmp.D2PCoef*(double(chDSec-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          elseif comprOption == 6
            dtRead = fread(fID,info.pageItemCount,'uint8');
            dataDec = NdfDcoder.DecompressVZD(dtRead,hDict,chCountAll,sampleRMax);
            for i=1:chCountR
              chname = char(strcat(chNames(i)));
              rowIdx = info.chRowDic(chname);
              chInfoTmp = chsDic(chname);
              sCount = chInfoTmp.SampleRate;
              minD =  chs(i).MinDigital;
              chDSec = dataDec(rowIdx,[1:sCount]);
              dataOneSec =chInfoTmp.MinPhysical + chInfoTmp.D2PCoef*(double(chDSec-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          else
            for i=1:chCountR
              chname = char(strcat(chNames(i)));
              pOffset = info.chIndexDic(chname);
              offset = pOffset;
              res = fseek(fID,offset,'cof');
              if(res~=0)
                  disp("fseek error");
              end
              chInfoTmp = chsDic(chname);
              width = chInfoTmp.bytesOneSample;
              sCount = chInfoTmp.SampleRate;
              bitWidth = width*8;
              readSrc = sprintf('bit%d=>int32',bitWidth);
              minD =  chInfoTmp.MinDigital;
              if minD>=0
                  readSrc = sprintf('ubit%d=>int32',bitWidth);
              end
              %chdata = fread(fID,sCount,readSrc);
              [chDSec,chDSecLen] = fread(fID,sCount,readSrc);
              if chDSecLen <1
                break;
              end
              dataOneSec =chInfoTmp.MinPhysical + chInfoTmp.D2PCoef*(double(chDSec-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          end
        end
        for i=1:chCountR
          chname = char(strcat(chNames(i)));
          chNameDataDic(char(chname)) = datas(i).Datas;
        end
        physicalDataRes = chNameDataDic;
        fclose(fID);
      end
      
      function physicalDataRes = readPeriodPhysicalValues_V1(obj,secOffset,secDur)
        info = obj.fInfo;
        bytesFrame = info.bytesChFrame;
        fp= obj.fPath;
        fmt = 'l';
        if( info.LE == false)
         fmt ='b';
        end
        fID = fopen(fp,'r',fmt);
        chsAll = info.channels;
        durationAll = info.recordDuration;
        chCountAll = info.chCount;
        chsDic = info.chInfoDic;
        durationR = secDur;
        offsetR = secOffset;

        chNameDataDic = containers.Map();
        for i=1:chCountAll
          chname = chsAll(i).ChannelName;
          sCount = chsAll(i).SampleRate;
          datas(i) = oneChannelData();
          datas(i).Datas = zeros(sCount,durationR);
        end

        for s = 1:durationR
          offset = 128+info.chCount*128+offsetR*bytesFrame+(s-1)* bytesFrame+1+info.maskCount;
          %fseek(fID,0,'bof');
          fseek(fID,offset,'bof');
          for i=1:chCountAll
            width = chsAll(i).bytesOneSample;
            sCount = chsAll(i).SampleRate;
            bitWidth = width*8;
            readSrc = sprintf('bit%d=>int32',bitWidth);
            minD =  chsAll(i).MinDigital;
            if minD>=0
              readSrc = sprintf('ubit%d=>int32',bitWidth);
            end
            chdata = fread(fID,sCount,readSrc);
            dataOneSec = chsAll(i).MinPhysical + chsAll(i).D2PCoef*(double(chdata-minD));
            datas(i).Datas(:,s) = dataOneSec;
          end
        end

        for i=1:chCountAll
          chname = strcat(chsAll(i).ChannelName);
          chNameDataDic(char(chname)) = datas(i).Datas;
        end

        physicalDataRes = chNameDataDic;
        fclose(fID);
      end
      
      function physicalDataRes = readPeriodPhysicalValues(obj,secOffset,secDur)
        if obj.fVersion == 0x01
           physicalDataRes = obj.readPeriodPhysicalValues_V1(secOffset,secDur);
           return;
        end
        info = obj.fInfo;
        bytesFrame = info.bytesChFrame;
        fp= obj.fPath;
        fmt = 'l';
        if( info.LE == false)
         fmt ='b';
        end
        fID = fopen(fp,'r',fmt);
        chsAll = info.channels;
        chs = chsAll;
        durationAll = info.recordDuration;
        chCountAll = info.chCount;
        chsDic = info.chInfoDic;
        duration = secDur;
        offsetR = secOffset;
        sampleRMax =  info.sampleMax;
        chCount = chCountAll;
        chNameDataDic = containers.Map();
        for i=1:chCountAll
          chname = chsAll(i).ChannelName;
          sCount = chsAll(i).SampleRate;
          datas(i) = oneChannelData();
          datas(i).Datas = zeros(sCount,duration);
        end
        dataPos = obj.getFPosFromTime(fID,offsetR,duration);
        NdfDcoder = NDFDecompression();
        hDictFpos = 0;
        hDict = [];
        for s = 1:duration
          fseek(fID,dataPos(s),'bof');
          dicPos = fread(fID,1,'uint64');
          comprOption = fread(fID,1,'uint8');
          dtLen = fread(fID,1,'uint32');
          
          if comprOption == 7
            dtRead = fread(fID,info.pageItemCount,'uint8');
            if dicPos ~= hDictFpos
              fseek(fID,dicPos+2,'bof');
              freqAr = fread(fID,256,'uint32');
              hDict = NdfDcoder.GenHuffmanTree(dicPos,freqAr);
            end
            dtRead = uint8(dtRead);
            dataDec = NdfDcoder.DecompressHVZD(dtRead,hDict,chCountAll,sampleRMax);
            for i = 1:chCount
              dataChI = dataDec(i,:);
              sCount = chs(i).SampleRate;
              chdata = dataChI(1:sCount);
              minD =  chs(i).MinDigital;
              dataOneSec =  chs(i).MinPhysical + chs(i).D2PCoef*(double(chdata-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          elseif comprOption == 6
            dtRead = fread(fID,info.pageItemCount,'uint8');
            dataDec = NdfDcoder.DecompressVZD(dtRead,hDict,chCount,sampleRMax);
            for i = 1:chCount
              dataChI = dataDec(i,:);
              sCount = chs(i).SampleRate;
              chdata = dataChI(1:sCount);
              minD =  chs(i).MinDigital;
              dataOneSec =  chs(i).MinPhysical + chs(i).D2PCoef*(double(chdata-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          else
            for i = 1:chCount
              width = chs(i).bytesOneSample;
              sCount = chs(i).SampleRate;
              bitWidth = width*8;
              readSrc = sprintf('bit%d=>int32',bitWidth);
              minD =  chs(i).MinDigital;
              if minD>=0
                readSrc = sprintf('ubit%d=>int32',bitWidth);
              end
              chdata = fread(fID,sCount,readSrc);
              dataOneSec =  chs(i).MinPhysical + chs(i).D2PCoef*(double(chdata-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          end
        end
        for i=1:chCountAll
          chname = strcat(chsAll(i).ChannelName);
          chNameDataDic(char(chname)) = datas(i).Datas;
        end

        physicalDataRes = chNameDataDic;
        fclose(fID);
      end
      
      function fPos = getFPosFromTime(obj,fID,tStart,tDuration)
        info = obj.fInfo;
        if tDuration<1
          tDuration = 1;
        end
        posAr = [tStart:tStart+tDuration-1];
        pageIndex = int32(posAr)/int32(info.pageItemCount);
        pageItemIndex = mode(posAr,info.pageItemCount);
        sOffsetPageItem = 144+128*info.chCount+4+64+pageIndex(1)*info.pageItemCount*4+pageItemIndex(1)*4;
        fseek(fID,sOffsetPageItem,'bof');
        pageItemV = fread(fID,tDuration,'uint32');
        fPos = info.pagesPosition(pageIndex+1)+pageItemV;
      end

      function physicalData = readAllPhysicalValues_V1(obj)
        info = obj.fInfo;
        duration = info.recordDuration;
        chCount = info.chCount;
        bytesFrame = info.bytesChFrame;
        fp= obj.fPath;
        fmt = 'l';
        if( info.LE == false)
          fmt ='b';
        end
        fID = fopen(fp,'r',fmt);
        chs = info.channels;
        chNameDataDic = containers.Map();
        for i=1:chCount
          chname = strcat(chs(i).ChannelName);
          sCount = chs(i).SampleRate;
          datas(i) = oneChannelData();
          datas(i).Datas = zeros(sCount,duration);
        end
        for s = 1:duration
          offset = 128+chCount*128+(s-1)* bytesFrame+1+info.maskCount;
          %fseek(fID,0,'bof');
          fseek(fID,offset,'bof');
          for i=1:chCount
            width = chs(i).bytesOneSample;
            sCount = chs(i).SampleRate;
            bitWidth = width*8;
            readSrc = sprintf('bit%d=>int32',bitWidth);
            minD =  chs(i).MinDigital;
            if minD>=0
              readSrc = sprintf('ubit%d=>int32',bitWidth);
            end
            chdata = fread(fID,sCount,readSrc);
            dataOneSec =  chs(i).MinPhysical + chs(i).D2PCoef*(double(chdata-minD));
            datas(i).Datas(:,s) = dataOneSec;
          end
        end

        for i=1:chCount
          chname = strcat(chs(i).ChannelName);
          chNameDataDic(char(chname)) = datas(i).Datas;
        end
        physicalData = chNameDataDic;
        fclose(fID);
      end

      function physicalData = readAllPhysicalValues(obj)
        info = obj.fInfo;
        if obj.fVersion == 0x01
           physicalData = obj.readAllPhysicalValues_V1();
           return;
        end
        
        duration = info.recordDuration;
        chCount = info.chCount;
        bytesFrame = info.bytesChFrame;
        fp= obj.fPath;
        fmt = 'l';
        if( info.LE == false)
          fmt ='b';
        end
        fID = fopen(fp,'r',fmt);
        chs = info.channels;
        chNameDataDic = containers.Map();
        sampleRMax =  info.sampleMax;
        for i=1:chCount
          chname = strcat(chs(i).ChannelName);
          sCount = chs(i).SampleRate;
          datas(i) = oneChannelData();
          datas(i).Datas = zeros(sCount,duration);
        end
        dataPos = obj.getFPosFromTime(fID,0,duration);
        NdfDcoder = NDFDecompression();
        hDictFpos = 0;
        hDict = [];
        for s = 1:duration
          fseek(fID,dataPos(s),'bof');
          dicPos = fread(fID,1,'uint64');
          comprOption = fread(fID,1,'uint8');
          dtLen = fread(fID,1,'uint32');
          
          if comprOption == 7
            dtRead = fread(fID,dtLen,'uint8');
            if dicPos ~= hDictFpos
              fseek(fID,dicPos+2,'bof');
              freqAr = fread(fID,256,'uint32');
              hDict = NdfDcoder.GenHuffmanTree(dicPos,freqAr);
            end
            dtRead = uint8(dtRead);
            dataDec = NdfDcoder.DecompressHVZD(dtRead,hDict,chCount,sampleRMax);
            for i = 1:chCount
              dataChI = dataDec(i,:);
              sCount = chs(i).SampleRate;
              chdata = dataChI(1:sCount);
              minD =  chs(i).MinDigital;
              dataOneSec =  chs(i).MinPhysical + chs(i).D2PCoef*(double(chdata-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          elseif comprOption == 6
            dtRead = fread(fID,info.pageItemCount,'uint8');
            dataDec = NdfDcoder.DecompressVZD(dtRead,hDict,chCount,sampleRMax);
            for i = 1:chCount
              dataChI = dataDec(i,:);
              sCount = chs(i).SampleRate;
              minD =  chs(i).MinDigital;
              chdata = dataChI(1:sCount);
              dataOneSec =  chs(i).MinPhysical + chs(i).D2PCoef*(double(chdata-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          else
            for i = 1:chCount
              width = chs(i).bytesOneSample;
              sCount = chs(i).SampleRate;
              bitWidth = width*8;
              readSrc = sprintf('bit%d=>int32',bitWidth);
              minD =  chs(i).MinDigital;
              if minD>=0
                readSrc = sprintf('ubit%d=>int32',bitWidth);
              end
              chdata = fread(fID,sCount,readSrc);
              dataOneSec =  chs(i).MinPhysical + chs(i).D2PCoef*(double(chdata-minD));
              datas(i).Datas(:,s) = dataOneSec;
            end
          end
        end
        for i=1:chCount
          chname = strcat(chs(i).ChannelName);
          chNameDataDic(char(chname)) = datas(i).Datas;
        end
        physicalData = chNameDataDic;
        fclose(fID);
    end
end

end