classdef fileNEF<handle
    properties
        fPath
		nefInfo
    end
    
    methods
        function obj = fileNEF(fpath)
            obj.fPath = fpath;
			obj.parse();
        end

		function parse(obj)
            fp= obj.fPath;
            fID = fopen(fp,'r','l');
            
            le = fread(fID,2,'uint8');          
            if le(1) == hex2dec('fe') && le(2) == hex2dec('ff')
                obj.nefInfo.LE = true;
            elseif le(2) == hex2dec('fe') && le(1) == hex2dec('ff')
                obj.nefInfo.LE = false;
                fclose(fID);
                fID = fopen(fp,'r','b');
            else
                disp('error');
                return            
            end         
            
            fseek(fID,9,'bof');
            obj.nefInfo.recordDate = fscanf(fID, "%4d.%2d.%2d",3);
            %fseek(fID,19,'bof');
            obj.nefInfo.recordTime = fscanf(fID, "%2d:%2d:%2d",3);
			%fseek(fID,0x1B,'bof');
            obj.nefInfo.singleDuration = fread(fID,1,'uint16');
			%fseek(fID,0x1D,'bof');
            eCount = fread(fID,1,'uint32');
			obj.nefInfo.eventCount = eCount;
			%fseek(fID,0x21,'bof');
            obj.nefInfo.eventDelCount = fread(fID,1,'uint32');
			fseek(fID,37,'bof');
            subID = fread(fID,16,'uint8');
			%obj.nefInfo.subID = strcat(char(subID)');
			obj.nefInfo.subID = subID;
            eventAr = repmat(struct('Annotation',[],'Remark',[],'EventIndex',0,'Onset',0,'Duration',0,'Color',0),1,eCount);
			fseek(fID,64,'bof');
            for i = 1:eCount
                delMark = fread(fID,1,'uint8');
                if delMark == false
                    fseek(fID,1004,'cof');
                    continue;
                end
                eID = fread(fID,1,'uint32');
                eventAr(i).EventIndex = eID;
                eOnset = fread(fID,1,'uint32');
                eventAr(i).Onset = eOnset;
                fseek(fID,2,'cof');
                eDuration = fread(fID,1,'uint32');
                eventAr(i).Duration = eDuration;
                fseek(fID,2,'cof');
                eColor = fread(fID,1,'uint32');
                eventAr(i).Color = eColor;
                fseek(fID,2,'cof');
                tmpBuffer = fread(fID,982,'uint8');
                strL = find(tmpBuffer==0);
                tmpBUfferChar = '';
                if(strL>2)
                    tmpBUfferChar = char(tmpBuffer(1:strL-2))';
                end
                
                eventAr(i).Annotation = strcat(tmpBUfferChar);
                
                if ~isempty(strL)
                    strStart = strL(1);
                    strEnd = 982;
                    if length(strL) >1
                        strEnd = strL(2)-2;
                        if(strEnd>strStart)
                            eventAr(i).Remark = strcat(tmpBUfferChar(strStart:strEnd));
                        else
                            eventAr(i).Remark = '';
                        end
                    else
                        if(strEnd>strStart)
                            eventAr(i).Remark = strcat(tmpBUfferChar(strStart:strEnd));
                        else
                            eventAr(i).Remark = '';
                        end
                    end
                end
                
            end
			
            obj.nefInfo.eventAr = eventAr;
		end
    end
    
end

