classdef fileNHF<handle
    properties
        fPath
		nhfInfo
    end
    
    methods
        function obj = fileNHF(fpath)
            obj.fPath = fpath;
			obj.parse();
        end
        
        function nhfInfo = parse(obj)
            fp= obj.fPath;
            fID = fopen(fp,'r','l');
            
            le = fread(fID,2,'uint8');          
            if le(1) == hex2dec('fe') && le(2) == hex2dec('ff')'
                ntpInfo.LE = true;
            elseif le(2) == hex2dec('fe') && le(1) == hex2dec('ff')'
                ntpInfo.LE = false;
                fclose(fID);
                fID = fopen(fp,'r','b');
            else
                disp('error');
                return            
            end         
            
            fseek(fID,29,'bof');
            hCount = fread(fID,1,'uint8');
            nhfInfo.hostCount  = hCount;
            
            %fseek(fID,30,'bof');
            hRecord = fread(fID,1,'uint8');
            nhfInfo.RecordCount  = hRecord;
            
            %fseek(fID,31,'bof');
            nhfInfo.subID = fread(fID,16,'uint8');
            
            %fseek(fID,47,'bof');
            nhfInfo.examID = fread(fID,16,'uint8');
            
            hosts = repmat( struct('name','0','folder','0'),  1, hCount);
            isASCII = true;
            hostProbeNameMapDic = containers.Map();
            for i = 1:hCount
                fseek(fID,80+(i-1)*96,'bof');
                %sub.participantInfo = fread(fID,16,'uint8');
                vName = fread(fID,40,'uint8');
                %hosts(i).name = char(vName);
                %hosts(i).name = strcat(char(vName)');
                hosts(i).name = NDFDecoder.Decode(vName);
                vfolder = fread(fID,40,'uint8');
                %hosts(i).folder = char(vfolder);
                %hosts(i).folder = strcat(char(vfolder)');
                vfolderDec = NDFDecoder.Decode(vfolder);
                hosts(i).folder = vfolderDec;
                formatSpec = "probe%d";
                hostNameNew = sprintf(formatSpec,i);
                hostProbeNameMapDic(vfolderDec)=hostNameNew;
                if ~NDFDecoder.IsASCII(vfolder)
                    isASCII=false;
                end
            end
            nhfInfo.IsHostNameASCII = isASCII;
            nhfInfo.hostNameCodeMap = hostProbeNameMapDic;
            nhfInfo.hosts = hosts;
            
            videos = repmat( struct('camera','0','folder','0'),  1, hRecord);
            
            for i = 1:hRecord
                fseek(fID,80+hCount*96+(i-1)*96,'bof');
                %sub.participantInfo = fread(fID,16,'uint8');
                vCamera = fread(fID,40,'uint8');
                %videos(i).camera = char(vCamera);
                videos(i).camera = NDFDecoder.Decode(vCamera);
				
                vfolder = fread(fID,40,'uint8');
                %videos(i).folder = char(vfolder);
                videos(i).folder = NDFDecoder.Decode(vfolder);
            end
                    
            nhfInfo.videos = videos;
			obj.nhfInfo = nhfInfo;
        end
    end
end

