classdef fileNSF<handle
    properties
        fPath
		nsfInfo
    end
    
    methods
        function obj = fileNSF(fpath)
            obj.fPath = fpath;
			obj.parse();
        end
        
        function nsfInfo = parse(obj)
            fp = obj.fPath;
            fID = fopen(fp,'r','l');
            
            le = fread(fID,2,'uint8');          
            if le(1) == hex2dec('fe') && le(2) == hex2dec('ff')
                nsfInfo.LE = true;
            elseif le(2) == hex2dec('fe') && le(1) == hex2dec('ff')
                nsfInfo.LE = false;
                fclose(fID);
                fID = fopen(fp,'r','b');
            else
                disp('error');
                return            
            end         
            
            fseek(fID,11,'bof');
            gd = fread(fID,2,'uint8');
            gend = char(gd);
            if(gend(1)=='M')
                nsfInfo.isMale = true;
            elseif (gend(1)=='F')
                nsfInfo.isMale = false;
            end
           
            %nsfInfo.name = fread(fID,20,'uint8');
            na = fread(fID,20,'uint8');
            %nsfInfo.name = strcat(char(na)');
            nsfInfo.name = NDFDecoder.Decode(na);
            %fseek(fID,0x21,'bof');
            nsfInfo.birthday = fscanf(fID, "%4d.%2d.%2d",3);
            
            %fseek(fID,11,'bof');
            nsfInfo.recordDate = fscanf(fID, "%4d.%2d.%2d",3);
            
            %fseek(fID,21,'bof');
            nsfInfo.recordTime = fscanf(fID, "%2d:%2d:%2d",3);
            
            %fseek(fID,0x3D,'bof');
            nsfInfo.recordDuration = fread(fID,1,'uint32');
            
             %fseek(fID,0x41,'bof');
            chCount = fread(fID,1,'uint16');
            nsfInfo.chCount = chCount;
             %fseek(fID,0x43,'bof');
            segCnt = fread(fID,1,'uint16');
            nsfInfo.segCount = segCnt;
            %0x46
			fseek(fID,67,'bof');
            subID = fread(fID,16,'uint8');
			nsfInfo.subID = strcat(char(subID)');

            chs = repmat(struct('ChannelName',[],'ChannelType',[],'TransducerType',[],'PreFilter',[],'Unit',[],'ByteCount',0,'SampleRate',0,'MaxDigital',0,'MinDigital',0,'MaxPhysical',0,'MinPhysical',0,'ChannelOffset',0),1,nsfInfo.chCount);
            chNameInfoDic = containers.Map();
            for i = 1:chCount
                fseek(fID,128+(i-1)*128,'bof');
                %sub.participantInfo = fread(fID,16,'uint8');
                chName = fread(fID,20,'uint8');
                chs(i).ChannelName = strcat(char(chName)');
                chType = fread(fID,20,'uint8');
                chs(i).ChannelType = char(chType);
                tType = fread(fID,8,'uint8');
                chs(i).TransducerType = char(tType);
				pFileter = fread(fID,20,'uint8');
                chs(i).PreFilter = char(pFileter);
				unit = fread(fID,8,'uint8');
                chs(i).Unit = char(unit);
				bytes = fread(fID,1,'uint8');
                chs(i).ByteCount = bytes;
				%sampleR = fread(fID,1,'int32');
                sampleR = fread(fID,1,'uint16');
                %tmpPos = fread(fID,1,'uint16');
                chs(i).SampleRate = sampleR;
				maxD = fread(fID,1,'int32');
                chs(i).MaxDigital = maxD;
				minD = fread(fID,1,'int32');
                chs(i).MinDigital = minD;
				maxP = fread(fID,1,'float32');
                chs(i).MaxPhysical = maxP;
				chOffset = fread(fID,1,'int32');
                chs(i).ChannelOffset = chOffset;
				chNameInfoDic(chs(i).ChannelName) = chs(i);
            end
            
            nsfInfo.channels = chs;
			nsfInfo.chInfoDic = chNameInfoDic;
            
            segs = repmat(struct('SegmentFolderName',[],'IsContinous',false,'StartSecond',0,'Duration',0,'StopSecond',0),1,segCnt);
            segStartAr = zeros(segCnt);
            segStopAr = zeros(segCnt);
            for i = 1:segCnt
                fseek(fID,128+chCount*128+(i-1)*48,'bof');
                flName = fread(fID,20,'uint8');
                %segs(i).SegmentFolderName = strcat(char(flName)');
				
                segs(i).SegmentFolderName = NDFDecoder.Decode(flName);
                isContonius = fread(fID,1,'uint8');
                %segs(i).IsContinous = boolean(isContonius);
                segs(i).IsContinous = isContonius;
                start = fread(fID,1,'int32');
                segs(i).StartSecond = start;
                segStartAr(i) = start;
                dur = fread(fID,1,'int32');
                segs(i).Duration = dur;
                stopSi = start+dur;
                segs(i).StopSecond = stopSi;
                segStopAr(i)=stopSi;
                segs(i).Index = i;
            end
            nsfInfo.segs = segs;
            nsfInfo.StartS = min(segStartAr(:));
            nsfInfo.StopS = max(segStopAr(:));
            durCal = nsfInfo.StopS - nsfInfo.StartS;
            if durCal < nsfInfo.recordDuration
                nsfInfo.DurationCal = nsfInfo.recordDuration;
            else
                 nsfInfo.DurationCal = durCal;
            end
			obj.nsfInfo = nsfInfo;
        end
    end
end

