classdef fileNTP
    properties
        fPath
    end
    
    methods
        function obj = fileNTP(fpath)
            obj.fPath = fpath;
            obj.parse();
        end
        
        function ntpInfo = parse(obj)
            fp= obj.fPath;
            fID = fopen(fp,'r','l');
            
            le = fread(fID,2,'uint8');          
            if le(1) == hex2dec('fe') && le(2) == hex2dec('ff')'
                ntpInfo.LE = true;
            elseif le(2) == hex2dec('fe') && le(1) == hex2dec('ff')'
                ntpInfo.LE = false;
                fclose(fID);
                fID = fopen(fp,'r','b');
            else
                disp('error');
                return            
            end
            
            fseek(fID,11,'bof');
            ntpInfo.recordDate = fscanf(fID, "%4d.%2d.%2d",3);
            
            fseek(fID,21,'bof');
            ntpInfo.recordTime = fscanf(fID, "%2d:%2d:%2d",3);
            
            fseek(fID,29,'bof');
            subCount = fread(fID,1,'uint8');
            ntpInfo.subCount  = subCount;
            
            %fseek(fID,30,'bof');
            ntpInfo.isSensor = fread(fID,1,'uint8');
            
            %fseek(fID,31,'bof');
            ntpInfo.examID = fread(fID,16,'uint8');
            
            %subs=[];
            subs = repmat(struct('participantInfo',[],'subjectID',[],'folderName',[],'isSensor',[]),  1, subCount);
            
            for i = 1:ntpInfo.subCount
                fseek(fID,64+(i-1)*112,'bof');
                %sub.participantInfo = fread(fID,16,'uint8');
                vInfo = fread(fID,40,'uint8');
                subs(i).participantInfo = char(vInfo);
                vID = fread(fID,16,'uint8');
                subs(i).subjectID = vID;
                vfName = fread(fID,40,'uint8');
                %tf = vfName<128;
                %isEn = all(tf(:));
                %if isEn
                 %   subs(i).folderName = strcat(char(vfName)');
                %else   
                %    strCh = native2unicode(vfName,'GB2312'); %'GB2312'
                %    subs(i).folderName = strcat(strCh');
                %end     
                subs(i).folderName = NDFDecoder.Decode(vfName);
                vSen = fread(fID,1,'uint8');
                subs(i).isSensor = logical(vSen);
            end
            
            ntpInfo.subs = subs;
            
            fclose(fID);
        end
    end
end

